////////////////////////////////////////////////////////////////////////////
///
/// \file aln_matrices.c
///
/// \author Benjamin Grenier-Boley <benjamin.grenier-boley@inria.fr>
///
/// \brief File that contains functions for the mangement of matrices
///
/// \version 1.02
///
/// \date September 2008
///
///
/// This file will define functions for the mangement of matrices
///
///
/////////////////////////////////////////////////////////////////////////////

/*Intern inclusion*/
#include "aln_matrices.h"


/******************************************************************************
 **   Definition of a basic blosum DNA matrix
 **     
 *****************************************************************************/

blosum_dna_matrix_t dna_full = {
  {5,-4,-4,-4, -2},
  {-4,5,-4,-4, -2},
  {-4,-4,5,-4, -2},
  {-4,-4,-4,5, -2},
  {-2,-2,-2,-2,-1}};


/******************************************************************************
 **   Definition of IUPAC blosum DNA matrices
 **     
 *****************************************************************************/

blosum_iupac_matrix_t iupac_mat = {
  {5,-4,-4,-4,-4,1,1,-4,-4,1,-4,-1,-1,-1,-2,-4},
  {-4,5,-4,-4,-4,1,-4,1,1,-4,-1,-4,-1,-1,-2,5},
  {-4,-4,5,-4,1,-4,1,-4,1,-4,-1,-1,-4,-1,-2,-4},
  {-4,-4,-4,5,1,-4,-4,1,-4,1,-1,-1,-1,-4,-2,-4},
  {-4,-4,1,1,-1,-4,-2,-2,-2,-2,-1,-1,-3,-3,-1,-4},
  {1,1,-4,-4,-4,-1,-2,-2,-2,-2,-3,-3,-1,-1,-1,1},
  {1,-4,1,-4,-2,-2,-1,-4,-2,-2,-3,-1,-3,-1,-1,-4},
  {-4,1,-4,1,-2,-2,-4,-1,-2,-2,-1,-3,-1,-3,-1,1},
  {-4,1,1,-4,-2,-2,-2,-2,-1,-4,-1,-3,-3,-1,-1,1},
  {1,-4,-4,1,-2,-2,-2,-2,-4,-1,-3,-1,-1,-3,-1,-4},
  {-4,-1,-1,-1,-1,-3,-3,-1,-1,-3,-1,-2,-2,-2,-1,-1},
  {-1,-4,-1,-1,-1,-3,-1,-3,-3,-1,-2,-1,-2,-2,-1,-4},
  {-1,-1,-4,-1,-3,-1,-3,-1,-3,-1,-2,-2,-1,-2,-1,-1},
  {-1,-1,-1,-4,-3,-1,-1,-3,-1,-3,-2,-2,-2,-1,-1,-1},
  {-2,-2,-2,-2,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-2},
  {-4,5,-4,-4,-4,1,-4,1,1,-4,-1,-4,-1,-1,-2,5}};


blosum_iupac_matrix_t iupac_full = {
  {5,-4,-4,-4,-4,1,1,-4,-4,1,-4,-1,-1,-1,-2,-4},
  {-4,5,-4,-4,-4,1,-4,1,1,-4,-1,-4,-1,-1,-2,5},
  {-4,-4,5,-4,1,-4,1,-4,1,-4,-1,-1,-4,-1,-2,-4},
  {-4,-4,-4,5,1,-4,-4,1,-4,1,-1,-1,-1,-4,-2,-4},
  {-4,-4,1,1,-1,-4,-2,-2,-2,-2,-1,-1,-3,-3,-1,-4},
  {1,1,-4,-4,-4,-1,-2,-2,-2,-2,-3,-3,-1,-1,-1,1},
  {1,-4,1,-4,-2,-2,-1,-4,-2,-2,-3,-1,-3,-1,-1,-4},
  {-4,1,-4,1,-2,-2,-4,-1,-2,-2,-1,-3,-1,-3,-1,1},
  {-4,1,1,-4,-2,-2,-2,-2,-1,-4,-1,-3,-3,-1,-1,1},
  {1,-4,-4,1,-2,-2,-2,-2,-4,-1,-3,-1,-1,-3,-1,-4},
  {-4,-1,-1,-1,-1,-3,-3,-1,-1,-3,-1,-2,-2,-2,-1,-1},
  {-1,-4,-1,-1,-1,-3,-1,-3,-3,-1,-2,-1,-2,-2,-1,-4},
  {-1,-1,-4,-1,-3,-1,-3,-1,-3,-1,-2,-2,-1,-2,-1,-1},
  {-1,-1,-1,-4,-3,-1,-1,-3,-1,-3,-2,-2,-2,-1,-1,-1},
  {-2,-2,-2,-2,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-2},
  {-4,5,-4,-4,-4,1,-4,1,1,-4,-1,-4,-1,-1,-2,5}};
